diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/config.h ns-3.32/src/core/model/config.h
--- ns-3.31/src/core/model/config.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/config.h	2020-10-06 15:35:43.000000000 -0700
@@ -62,11 +62,14 @@
  *
  * This function will attempt to find attributes which
  * match the input path and will then set their value to the input
- * value.
+ * value.  If no such attributes are found, the function will throw
+ * a fatal error; use SetFailSafe if the lack of a match is to be permitted.
  */
 void Set (std::string path, const AttributeValue &value);
 /**
- * \copydoc Set()
+ * This function will attempt to find attributes which
+ * match the input path and will then set their value to the input
+ * value, and will return true if at least one such attribute is found.
  * \return \c true if any matching attributes could be set.
  */
 bool SetFailSafe (std::string path, const AttributeValue &value);
@@ -114,11 +117,16 @@
  *
  * This function will attempt to find all trace sources which
  * match the input path and will then connect the input callback
- * to them.
+ * to them.  If no matching trace sources are found, this method will 
+ * throw a fatal error.  Use ConnectWithoutContextFailSafe if the absence
+ * of matching trace sources should not be fatal.
  */
 void ConnectWithoutContext (std::string path, const CallbackBase &cb);
 /**
- * \copydoc ConnectWithoutContext()
+ * This function will attempt to find all trace sources which
+ * match the input path and will then connect the input callback
+ * to them.  If no matching trace sources are found, this method will 
+ * return false; otherwise true.
  * \returns \c true if any trace sources could be connected.
  */
 bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb);
@@ -139,10 +147,16 @@
  * match the input path and will then connect the input callback
  * to them in such a way that the callback will receive an extra
  * context string upon trace event notification.
+ * If no matching trace sources are found, this method will 
+ * throw a fatal error.  Use ConnectFailSafe if the absence
+ * of matching trace sources should not be fatal.
  */
 void Connect (std::string path, const CallbackBase &cb);
 /**
- * \copydoc Connect()
+ * This function will attempt to find all trace sources which
+ * match the input path and will then connect the input callback
+ * to them in such a way that the callback will receive an extra
+ * context string upon trace event notification.
  * \returns \c true if any trace sources could be connected.
  */
 bool ConnectFailSafe (std::string path, const CallbackBase &cb);
@@ -215,12 +229,16 @@
    * \param [in] value Value to set to the attribute
    *
    * Set the specified attribute value to all the objects stored in this
-   * container.
+   * container.  This method will raise a fatal error if no such attribute
+   * exists; use SetFailSafe if the absence of the attribute is to be
+   * permitted.  
    * \sa ns3::Config::Set
    */
   void Set (std::string name, const AttributeValue &value);
   /**
-   * \copydoc Set()
+   * Set the specified attribute value to all the objects stored in this
+   * container.  This method will return true if any attributes could be
+   * set, and false otherwise.
    * \returns \c true if any attributes could be set.
    */
   bool SetFailSafe (std::string name, const AttributeValue &value);
@@ -229,12 +247,16 @@
    * \param [in] cb The sink to connect to the trace source
    *
    * Connect the specified sink to all the objects stored in this
-   * container.
+   * container.  This method will raise a fatal error if no objects could
+   * be connected; use ConnectFailSafe if no connections is a valid possible
+   * outcome.
    * \sa ns3::Config::Connect
    */
   void Connect (std::string name, const CallbackBase &cb);
   /**
-   * \copydoc Connect()
+   * Connect the specified sink to all the objects stored in this
+   * container.  This method will return true if any trace sources could be
+   * connected, and false otherwise.
    * \returns \c true if any trace sources could be connected.
    */
   bool ConnectFailSafe (std::string name, const CallbackBase &cb);
@@ -243,12 +265,16 @@
    * \param [in] cb The sink to connect to the trace source
    *
    * Connect the specified sink to all the objects stored in this
-   * container.
+   * container.  This method will raise a fatal error if no objects could
+   * be connected; use ConnectWithoutContextFailSafe if no connections is
+   * a valid possible outcome.
    * \sa ns3::Config::ConnectWithoutContext
    */
   void ConnectWithoutContext (std::string name, const CallbackBase &cb);
   /**
-   * \copydoc ConnectWithoutContext()
+   * Connect the specified sink to all the objects stored in this
+   * container.  This method will return true if any trace sources could be
+   * connected, and false otherwise.
    * \returns \c true if any trace sources could be connected.
    */
   bool ConnectWithoutContextFailSafe (std::string name, const CallbackBase &cb);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/deprecated.h ns-3.32/src/core/model/deprecated.h
--- ns-3.31/src/core/model/deprecated.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/deprecated.h	2020-10-06 15:35:43.000000000 -0700
@@ -64,6 +64,15 @@
 
 /**
  * \ingroup core
+ * \def NS_DEPRECATED_3_32
+ * Tag for things deprecated in version ns-3.32.
+ */
+#ifdef NS_DEPRECATED
+#define NS_DEPRECATED_3_32 NS_DEPRECATED
+#endif
+
+/**
+ * \ingroup core
  * \def NS_DEPRECATED_3_31
  * Tag for things deprecated in version ns-3.31.
  */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/enum.cc ns-3.32/src/core/model/enum.cc
--- ns-3.31/src/core/model/enum.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/enum.cc	2020-10-06 15:35:43.000000000 -0700
@@ -176,144 +176,4 @@
 }
 
 
-Ptr<const AttributeChecker>
-MakeEnumChecker (int v1, std::string n1,
-                 int v2, std::string n2,
-                 int v3, std::string n3,
-                 int v4, std::string n4,
-                 int v5, std::string n5,
-                 int v6, std::string n6,
-                 int v7, std::string n7,
-                 int v8, std::string n8,
-                 int v9, std::string n9,
-                 int v10, std::string n10,
-                 int v11, std::string n11,
-                 int v12, std::string n12,
-                 int v13, std::string n13,
-                 int v14, std::string n14,
-                 int v15, std::string n15,
-                 int v16, std::string n16,
-                 int v17, std::string n17,
-                 int v18, std::string n18,
-                 int v19, std::string n19,
-                 int v20, std::string n20,
-                 int v21, std::string n21,
-                 int v22, std::string n22)
-{
-  NS_LOG_FUNCTION (v1 << n1 << v2 << n2 << v3 << n3 << v4 << n4 << v5 << n5 <<
-                   v6 << n6 << v7 << n7 << v8 << n8 << v9 << n9 << v10 << n10 <<
-                   v11 << n11 << v12 << n12 << v13 << n13 << v14 << n14 <<
-                   v15 << n15 << v16 << n16 << v17 << n17 << v18 << n18 <<
-                   v19 << n19 << v20 << n20 << v21 << n21 << v22 << n22);
-  Ptr<EnumChecker> checker = Create<EnumChecker> ();
-  checker->AddDefault (v1, n1);
-  if (n2 == "")
-    {
-      return checker;
-    }
-  checker->Add (v2, n2);
-  if (n3 == "")
-    {
-      return checker;
-    }
-  checker->Add (v3, n3);
-  if (n4 == "")
-    {
-      return checker;
-    }
-  checker->Add (v4, n4);
-  if (n5 == "")
-    {
-      return checker;
-    }
-  checker->Add (v5, n5);
-  if (n6 == "")
-    {
-      return checker;
-    }
-  checker->Add (v6, n6);
-  if (n7 == "")
-    {
-      return checker;
-    }
-  checker->Add (v7, n7);
-  if (n8 == "")
-    {
-      return checker;
-    }
-  checker->Add (v8, n8);
-  if (n9 == "")
-    {
-      return checker;
-    }
-  checker->Add (v9, n9);
-  if (n10 == "")
-    {
-      return checker;
-    }
-  checker->Add (v10, n10);
-  if (n11 == "")
-    {
-      return checker;
-    }
-  checker->Add (v11, n11);
-  if (n12 == "")
-    {
-      return checker;
-    }
-  checker->Add (v12, n12);
-  if (n13 == "")
-    {
-      return checker;
-    }
-  checker->Add (v13, n13);
-  if (n14 == "")
-    {
-      return checker;
-    }
-  checker->Add (v14, n14);
-  if (n15 == "")
-    {
-      return checker;
-    }
-  checker->Add (v15, n15);
-  if (n16 == "")
-    {
-      return checker;
-    }
-  checker->Add (v16, n16);
-  if (n17 == "")
-    {
-      return checker;
-    }
-  checker->Add (v17, n17);
-  if (n18 == "")
-    {
-      return checker;
-    }
-  checker->Add (v18, n18);
-  if (n19 == "")
-    {
-      return checker;
-    }
-  checker->Add (v19, n19);
-  if (n20 == "")
-    {
-      return checker;
-    }
-  checker->Add (v20, n20);
-  if (n21 == "")
-    {
-      return checker;
-    }
-  checker->Add (v21, n21);
-  if (n22 == "")
-    {
-      return checker;
-    }
-  checker->Add (v22, n22);
-  return checker;
-}
-
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/enum.h ns-3.32/src/core/model/enum.h
--- ns-3.31/src/core/model/enum.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/enum.h	2020-10-06 15:35:43.000000000 -0700
@@ -113,7 +113,7 @@
    * \returns The enum value.
    */
   int GetValue (const std::string name) const;
-  
+
   // Inherited
   virtual bool Check (const AttributeValue &value) const;
   virtual std::string GetValueTypeName (void) const;
@@ -145,81 +145,59 @@
  * with matching names.  For example,
  * \c MakeEnumChecker (RipNg::SPLIT_HORIZON, "ns3::RipNg::SplitHorizon");
  *
+ * As many additional enum value, name pairs as desired can be passed
+ * as arguments.
+ *
  * \see AttributeChecker
  *
+ * \tparam Ts The type list of additional parameters. Additional parameters
+ *            should be int, string pairs.
+ * \returns The AttributeChecker
+ * \param [in] v  The default enum value.
+ * \param [in] n  The corresponding name.
+ */
+template <typename... Ts>
+Ptr<const AttributeChecker>
+MakeEnumChecker (int v, std::string n, Ts... args)
+{
+  Ptr<EnumChecker> checker = Create<EnumChecker> ();
+  checker->AddDefault (v, n);
+  return MakeEnumChecker (checker, args...);
+}
+
+/**
+ * Handler for enum value, name pairs other than the default.
+ *
+ * \tparam Ts The type list of additional parameters. Additional parameters
+ *            should be in int, string pairs.
  * \returns The AttributeChecker
- * \param [in] v1  An enum value
- * \param [in] n1  The corresponding name.
- * \param [in] v2  A enum value
- * \param [in] n2  The corresponding name.
- * \param [in] v3  A enum value
- * \param [in] n3  The corresponding name.
- * \param [in] v4  A enum value
- * \param [in] n4  The corresponding name.
- * \param [in] v5  A enum value
- * \param [in] n5  The corresponding name.
- * \param [in] v6  A enum value
- * \param [in] n6  The corresponding name.
- * \param [in] v7  A enum value
- * \param [in] n7  The corresponding name.
- * \param [in] v8  A enum value
- * \param [in] n8  The corresponding name.
- * \param [in] v9  A enum value
- * \param [in] n9  The corresponding name.
- * \param [in] v10 An enum value
- * \param [in] n10 The enum name.
- * \param [in] v11 An enum value
- * \param [in] n11 The corresponding name.
- * \param [in] v12 A enum value
- * \param [in] n12 The corresponding name.
- * \param [in] v13 A enum value
- * \param [in] n13 The corresponding name.
- * \param [in] v14 A enum value
- * \param [in] n14 The corresponding name.
- * \param [in] v15 A enum value
- * \param [in] n15 The corresponding name.
- * \param [in] v16 A enum value
- * \param [in] n16 The corresponding name.
- * \param [in] v17 A enum value
- * \param [in] n17 The corresponding name.
- * \param [in] v18 A enum value
- * \param [in] n18 The corresponding name.
- * \param [in] v19 A enum value
- * \param [in] n19 The corresponding name.
- * \param [in] v20 An enum value
- * \param [in] n20 The enum name.
- * \param [in] v21 An enum value
- * \param [in] n21 The corresponding name.
- * \param [in] v22 A enum value
- * \param [in] n22 The corresponding name.
+ * \param [in] checker The AttributeChecker.
+ * \param [in] v  The next enum value.
+ * \param [in] n  The corresponding name.
  */
-Ptr<const AttributeChecker> MakeEnumChecker (int v1, std::string n1,
-                                             int v2 = 0, std::string n2 = "",
-                                             int v3 = 0, std::string n3 = "",
-                                             int v4 = 0, std::string n4 = "",
-                                             int v5 = 0, std::string n5 = "",
-                                             int v6 = 0, std::string n6 = "",
-                                             int v7 = 0, std::string n7 = "",
-                                             int v8 = 0, std::string n8 = "",
-                                             int v9 = 0, std::string n9 = "",
-                                             int v10 = 0, std::string n10 = "",
-                                             int v11 = 0, std::string n11 = "",
-                                             int v12 = 0, std::string n12 = "",
-                                             int v13 = 0, std::string n13 = "",
-                                             int v14 = 0, std::string n14 = "",
-                                             int v15 = 0, std::string n15 = "",
-                                             int v16 = 0, std::string n16 = "",
-                                             int v17 = 0, std::string n17 = "",
-                                             int v18 = 0, std::string n18 = "",
-                                             int v19 = 0, std::string n19 = "",
-                                             int v20 = 0, std::string n20 = "",
-                                             int v21 = 0, std::string n21 = "",
-                                             int v22 = 0, std::string n22 = "");
 
+template <typename... Ts>
+Ptr<const AttributeChecker>
+MakeEnumChecker (Ptr<EnumChecker> checker, int v, std::string n, Ts... args)
+{
+  checker->Add (v, n);
+  return MakeEnumChecker (checker, args...);
+}
 
-} // namespace ns3
+/**
+ * Terminate the recursion of variadic arguments.
+ *
+ * \returns The \pname checker
+ * \param [in] checker The AttributeChecker.
+ */
+// inline to allow tail call optimization
+inline
+Ptr<const AttributeChecker>
+MakeEnumChecker (Ptr<EnumChecker> checker)
+{
+  return checker;
+}
 
-namespace ns3 {
 
 template <typename T1>
 Ptr<const AttributeAccessor> MakeEnumAccessor (T1 a1)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/fatal-error.h ns-3.32/src/core/model/fatal-error.h
--- ns-3.31/src/core/model/fatal-error.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/fatal-error.h	2020-10-06 15:35:43.000000000 -0700
@@ -26,6 +26,7 @@
 #include <cstdlib>
 
 #include "fatal-impl.h"
+#include "log.h"  // NS_LOG_APPEND...
 
 /**
  * \file
@@ -72,6 +73,8 @@
 #define NS_FATAL_ERROR_IMPL_NO_MSG(fatal) \
   do                                                      \
     {                                                     \
+      NS_LOG_APPEND_TIME_PREFIX_IMPL;                     \
+      NS_LOG_APPEND_NODE_PREFIX_IMPL;                     \
       std::cerr << "file=" << __FILE__ << ", line=" <<    \
         __LINE__ << std::endl;                            \
       ::ns3::FatalImpl::FlushStreams ();                  \
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/log-macros-enabled.h ns-3.32/src/core/model/log-macros-enabled.h
--- ns-3.31/src/core/model/log-macros-enabled.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/log-macros-enabled.h	2020-10-06 15:35:43.000000000 -0700
@@ -27,8 +27,53 @@
  * NS_LOG and related logging macro definitions.
  */
 
-#ifdef NS3_LOG_ENABLE
 
+// These two implementation macros
+//   NS_LOG_APPEND_TIME_PREFIX_IMPL
+//   NS_LOG_APPEND_NODE_PREFIX_IMPL
+// need to be defined in all configurations (debug, release, optimized)
+// for use by NS_FATAL_...
+
+/**
+ * \ingroup logging
+ * Implementation details for NS_LOG_APPEND_TIME_PREFIX.
+ * \internal
+ * Logging implementation macro; should not be called directly.
+ * We define this separately so we can reuse the definition
+ * in NS_FATAL.
+ */
+#define NS_LOG_APPEND_TIME_PREFIX_IMPL                      \
+  do {                                                      \
+    ns3::TimePrinter printer = ns3::LogGetTimePrinter ();   \
+    if (printer != 0)                                       \
+      {                                                     \
+        (*printer)(std::clog);                              \
+        std::clog << " ";                                   \
+      }                                                     \
+  } while (false)
+
+/**
+ * \ingroup logging
+ * Implementation details for NS_LOG_APPEND_NODE_PREFIX.
+ * \internal
+ * Logging implementation macro; should not be called directly.
+ * We define this separately so we can reuse the definition
+ * in NS_FATAL.
+ */
+#define NS_LOG_APPEND_NODE_PREFIX_IMPL                      \
+  do {                                                      \
+    ns3::NodePrinter printer = ns3::LogGetNodePrinter ();   \
+    if (printer != 0)                                       \
+      {                                                     \
+        (*printer)(std::clog);                              \
+        std::clog << " ";                                   \
+      }                                                     \
+  } while (false)
+
+
+
+
+#ifdef NS3_LOG_ENABLE
 
 /**
  * \ingroup logging
@@ -36,15 +81,10 @@
  * \internal
  * Logging implementation macro; should not be called directly.
  */
-#define NS_LOG_APPEND_TIME_PREFIX                               \
-  if (g_log.IsEnabled (ns3::LOG_PREFIX_TIME))                   \
-    {                                                           \
-      ns3::TimePrinter printer = ns3::LogGetTimePrinter ();     \
-      if (printer != 0)                                         \
-        {                                                       \
-          (*printer)(std::clog);                                \
-          std::clog << " ";                                     \
-        }                                                       \
+#define NS_LOG_APPEND_TIME_PREFIX                           \
+  if (g_log.IsEnabled (ns3::LOG_PREFIX_TIME))               \
+    {                                                       \
+      NS_LOG_APPEND_TIME_PREFIX_IMPL;                       \
     }
 
 /**
@@ -53,15 +93,10 @@
  * \internal
  * Logging implementation macro; should not be called directly.
  */
-#define NS_LOG_APPEND_NODE_PREFIX                               \
-  if (g_log.IsEnabled (ns3::LOG_PREFIX_NODE))                   \
-    {                                                           \
-      ns3::NodePrinter printer = ns3::LogGetNodePrinter ();     \
-      if (printer != 0)                                         \
-        {                                                       \
-          (*printer)(std::clog);                                \
-          std::clog << " ";                                     \
-        }                                                       \
+#define NS_LOG_APPEND_NODE_PREFIX                          \
+  if (g_log.IsEnabled (ns3::LOG_PREFIX_NODE))              \
+    {                                                      \
+      NS_LOG_APPEND_NODE_PREFIX_IMPL;                      \
     }
 
 /**
@@ -70,12 +105,12 @@
  * \internal
  * Logging implementation macro; should not be called directly.
  */
-#define NS_LOG_APPEND_FUNC_PREFIX                               \
-  if (g_log.IsEnabled (ns3::LOG_PREFIX_FUNC))                   \
-    {                                                           \
-      std::clog << g_log.Name () << ":"                         \
-                << __FUNCTION__ << "(): ";                      \
-    }                                                           \
+#define NS_LOG_APPEND_FUNC_PREFIX                          \
+  if (g_log.IsEnabled (ns3::LOG_PREFIX_FUNC))              \
+    {                                                      \
+      std::clog << g_log.Name () << ":"                    \
+                << __FUNCTION__ << "(): ";                 \
+    }                                                      \
 
 /**
  * \ingroup logging
